#include "vec_utils.h"
#include <iostream>

CircularVector::CircularVector(std::size_t maxSize) : maxSize(maxSize) {
    // Initialize vector with maxSize number of elements
    circularVector.reserve(maxSize);
    std::fill(circularVector.begin(), circularVector.end(), 0);
}

void CircularVector::pushBack(int value) {
    if (circularVector.size() < maxSize) {
        // If the vector is not full, simply push back
        circularVector.push_back(value);
    } else {
        // If the vector is full, perform a circular push back
        circularVector[position] = value;
        // printf("%d value \n", value);
        position = (position + 1) % maxSize;
    }
}

ara::core::Vector<uint8_t>& CircularVector::getVector(){
    return circularVector;
}


void pushFloatToUint8Vector(float value, ara::core::Vector<uint8_t> &uint8Vector)
    {
        // Convert the float value to an array of bytes using a byte representation
        uint8_t bytes[sizeof(float)];
        memcpy(bytes, &value, sizeof(float));

        // Push each byte individually into the uint8_t vector
        for (int i = 0; i < sizeof(float); i++)
        {
            uint8Vector.push_back(bytes[i]);
        }
    }

void pushDoubleToUint8Vector(double value, ara::core::Vector<uint8_t> &uint8Vector)
{
    // Convert the float value to an array of bytes using a byte representation
    uint8_t bytes[sizeof(double)];
    memcpy(bytes, &value, sizeof(double));

    // Push each byte individually into the uint8_t vector
    for (int i = 0; i < sizeof(double); i++)
    {
        uint8Vector.push_back(bytes[i]);
    }
}

void pushSizeToUint8Vector(uint16_t value, uint8_t size, ara::core::Vector<uint8_t> &uint8Vector)
{
    uint8_t *bytes = new uint8_t[size];
    memcpy(bytes, &value, size);

    for (uint8_t i = 0; i < size; i++)
    {
        uint8Vector.push_back(bytes[i]);
    }
    delete[] bytes;
}